// -------------------------------------------------------------
// n
// 
// Copyright (c) 2003 IMAGIRE Takashi. All rights reserved.
// -------------------------------------------------------------

// -------------------------------------------------------------
// O[oϐ
// -------------------------------------------------------------

float  MAP_WIDTH;
float  MAP_HEIGHT;
float4 weight[8];
float2 offsetX;
float2 offsetY;

float4x4 mWVP;
float3 vEyePos;
float3 vLightDir;
float4 vCol;

// -------------------------------------------------------------
// eNX`
// -------------------------------------------------------------
texture SrcMap;
sampler SrcSamp = sampler_state
{
    Texture = <SrcMap>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
texture SrcMap2;
sampler SrcSamp2 = sampler_state
{
    Texture = <SrcMap2>;
    MinFilter = POINT;
    MagFilter = POINT;
    MipFilter = NONE;

    AddressU = Clamp;
    AddressV = Clamp;
};
// -------------------------------------------------------------
// _VF[_sNZVF[_ɓnf[^
// -------------------------------------------------------------
struct VS_OUTPUT
{
    float4 Pos			: POSITION;
    float2 ofset		: COLOR0;
	float2 Tex0			: TEXCOORD0;
	float2 Tex1			: TEXCOORD1;
	float2 Tex2			: TEXCOORD2;
	float2 Tex3			: TEXCOORD3;
	float2 Tex4			: TEXCOORD4;
	float2 Tex5			: TEXCOORD5;
	float2 Tex6			: TEXCOORD6;
	float2 Tex7			: TEXCOORD7;
};
// -------------------------------------------------------------
struct OUTPUT
{
    float4 Pos			: POSITION;
    float4 Color		: COLOR0;
	float3 Normal		: TEXCOORD0;
	float3 Eye			: TEXCOORD1;
};
// -------------------------------------------------------------
// V[̕`
// -------------------------------------------------------------
OUTPUT VS(
      float4 Pos    : POSITION,          // f̒_
      float3 Normal : NORMAL             // f̖@
){
	OUTPUT Out = (OUTPUT)0;        // o̓f[^
	float4  uv;
	
	// Wϊ
	Out.Pos = mul(Pos, mWVP);
	
	// F
	Out.Color = vCol * (0.7*max( dot(vLightDir, Normal), 0)+0.3);
	
	Out.Normal = Normal;		// F
	Out.Eye    = Pos - vEyePos;	// 
	
	return Out;
}
// -------------------------------------------------------------
float4 PS(OUTPUT In) : COLOR
{   
    float3 e = normalize(In.Eye);	// xNg
    float3 n = normalize(In.Normal);// @xNg
    float3 r = reflect(e,n);		// ˃xNg
	
	float power = pow(max(0,dot(r,vLightDir)), 32); // Phone
	float4 SpecCol = float4(5,5,5,0);			// ʔːF
	
    return In.Color + SpecCol * power;
}

// -------------------------------------------------------------
// kobt@֖邢𒊏o
// -------------------------------------------------------------
float4 PS_Reduction(VS_OUTPUT In) : COLOR
{   
    float4 Out;
    
	// 16{bNXTvO
	float2 t01 = float2( 0.0/512.0, 0.0/512.0);
	float2 t02 = float2( 0.0/512.0, 1.0/512.0);
	float2 t03 = float2( 0.0/512.0,-1.0/512.0);
	float2 t10 = float2(-1.0/512.0,-2.0/512.0);
	float2 t11 = float2(-1.0/512.0, 0.0/512.0);
	float2 t12 = float2(-1.0/512.0, 1.0/512.0);
	float2 t13 = float2(-1.0/512.0,-1.0/512.0);
	float2 t20 = float2( 1.0/512.0,-2.0/512.0);
	float2 t21 = float2( 1.0/512.0, 0.0/512.0);
	float2 t22 = float2( 1.0/512.0, 1.0/512.0);
	float2 t23 = float2( 1.0/512.0,-1.0/512.0);
	float2 t30 = float2(-2.0/512.0,-2.0/512.0);
	float2 t31 = float2(-2.0/512.0, 0.0/512.0);
	float2 t32 = float2(-2.0/512.0, 1.0/512.0);
	float2 t33 = float2(-2.0/512.0,-1.0/512.0);

	Out  =(tex2D( SrcSamp, In.Tex0 )   
		 + tex2D( SrcSamp, In.Tex0+t01 )
		 + tex2D( SrcSamp, In.Tex0+t02 )
		 + tex2D( SrcSamp, In.Tex0+t03 )
		 + tex2D( SrcSamp, In.Tex0+t10 )
		 + tex2D( SrcSamp, In.Tex0+t11 )
		 + tex2D( SrcSamp, In.Tex0+t12 )
		 + tex2D( SrcSamp, In.Tex0+t13 )
		 + tex2D( SrcSamp, In.Tex0+t20 )
		 + tex2D( SrcSamp, In.Tex0+t21 )
		 + tex2D( SrcSamp, In.Tex0+t22 )
		 + tex2D( SrcSamp, In.Tex0+t23 )
		 + tex2D( SrcSamp, In.Tex0+t30 )
 		 + tex2D( SrcSamp, In.Tex0+t31 )
		 + tex2D( SrcSamp, In.Tex0+t32 )
		 + tex2D( SrcSamp, In.Tex0+t33 ))/16;
	
	// 邢
	Out = 0.02f*exp(Out);
	
	return Out;
}
// -------------------------------------------------------------
// ɐL΂
// -------------------------------------------------------------
VS_OUTPUT VS_pass1 (
      float4 Pos    : POSITION,          // f̒_
      float4 Tex    : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    // ʒuW
    Out.Pos = Pos;
    
    Out.Tex0 = Tex + float2( -1.0f/MAP_WIDTH, 0.0f/MAP_HEIGHT );
    Out.Tex1 = Tex + float2( -2.0f/MAP_WIDTH, 0.0f/MAP_HEIGHT );
    Out.Tex2 = Tex + float2( -3.0f/MAP_WIDTH, 0.0f/MAP_HEIGHT );
    Out.Tex3 = Tex + float2( -4.0f/MAP_WIDTH, 0.0f/MAP_HEIGHT );
    Out.Tex4 = Tex + float2( -5.0f/MAP_WIDTH, 0.0f/MAP_HEIGHT );
    Out.Tex5 = Tex + float2( -6.0f/MAP_WIDTH, 0.0f/MAP_HEIGHT );
    Out.Tex6 = Tex + float2( -7.0f/MAP_WIDTH, 0.0f/MAP_HEIGHT );
    Out.Tex7 = Tex + float2( -8.0f/MAP_WIDTH, 0.0f/MAP_HEIGHT );
    
    return Out;
}
// -------------------------------------------------------------
float4 PS_pass1(VS_OUTPUT In) : COLOR
{   
    float4 Color;
	
	Color  = weight[0] * (tex2D( SrcSamp, In.Tex0 )
						+ tex2D( SrcSamp, In.Tex7 + offsetX ));
	Color += weight[1] * (tex2D( SrcSamp, In.Tex1 )
						+ tex2D( SrcSamp, In.Tex6 + offsetX ));
	Color += weight[2] * (tex2D( SrcSamp, In.Tex2 )
						+ tex2D( SrcSamp, In.Tex5 + offsetX ));
	Color += weight[3] * (tex2D( SrcSamp, In.Tex3 )
						+ tex2D( SrcSamp, In.Tex4 + offsetX ));
	Color += weight[4] * (tex2D( SrcSamp, In.Tex4 )
						+ tex2D( SrcSamp, In.Tex3 + offsetX ));
	Color += weight[5] * (tex2D( SrcSamp, In.Tex5 )
						+ tex2D( SrcSamp, In.Tex2 + offsetX ));
	Color += weight[6] * (tex2D( SrcSamp, In.Tex6 )
						+ tex2D( SrcSamp, In.Tex1 + offsetX ));
	Color += weight[7] * (tex2D( SrcSamp, In.Tex7 )
						+ tex2D( SrcSamp, In.Tex0 + offsetX ));
	
    return Color;
}
// -------------------------------------------------------------
// ɐL΂
// -------------------------------------------------------------
VS_OUTPUT VS_pass2 (
      float4 Pos    : POSITION,          // f̒_
      float4 Tex    : TEXCOORD0	         // eNX`W
){
    VS_OUTPUT Out = (VS_OUTPUT)0;        // o̓f[^
    
    // ʒuW
    Out.Pos = Pos;
    
    Out.Tex0 = Tex + float2( 0.0f/MAP_WIDTH, -1.0f/MAP_HEIGHT );
    Out.Tex1 = Tex + float2( 0.0f/MAP_WIDTH, -2.0f/MAP_HEIGHT );
    Out.Tex2 = Tex + float2( 0.0f/MAP_WIDTH, -3.0f/MAP_HEIGHT );
    Out.Tex3 = Tex + float2( 0.0f/MAP_WIDTH, -4.0f/MAP_HEIGHT );
    Out.Tex4 = Tex + float2( 0.0f/MAP_WIDTH, -5.0f/MAP_HEIGHT );
    Out.Tex5 = Tex + float2( 0.0f/MAP_WIDTH, -6.0f/MAP_HEIGHT );
    Out.Tex6 = Tex + float2( 0.0f/MAP_WIDTH, -7.0f/MAP_HEIGHT );
    Out.Tex7 = Tex + float2( 0.0f/MAP_WIDTH, -8.0f/MAP_HEIGHT );
    
    return Out;
}
// -------------------------------------------------------------
float4 PS_pass2(VS_OUTPUT In) : COLOR
{   
    float4 Color;
	
	Color  = weight[0] * (tex2D( SrcSamp, In.Tex0 )
						+ tex2D( SrcSamp, In.Tex7 + offsetY ));
	Color += weight[1] * (tex2D( SrcSamp, In.Tex1 )
						+ tex2D( SrcSamp, In.Tex6 + offsetY ));
	Color += weight[2] * (tex2D( SrcSamp, In.Tex2 )
						+ tex2D( SrcSamp, In.Tex5 + offsetY ));
	Color += weight[3] * (tex2D( SrcSamp, In.Tex3 )
						+ tex2D( SrcSamp, In.Tex4 + offsetY ));
	Color += weight[4] * (tex2D( SrcSamp, In.Tex4 )
						+ tex2D( SrcSamp, In.Tex3 + offsetY ));
	Color += weight[5] * (tex2D( SrcSamp, In.Tex5 )
						+ tex2D( SrcSamp, In.Tex2 + offsetY ));
	Color += weight[6] * (tex2D( SrcSamp, In.Tex6 )
						+ tex2D( SrcSamp, In.Tex1 + offsetY ));
	Color += weight[7] * (tex2D( SrcSamp, In.Tex7 )
						+ tex2D( SrcSamp, In.Tex0 + offsetY ));
	
    return Color;
}
// -------------------------------------------------------------
// ŏIIɍ
// -------------------------------------------------------------
float4 PS_pass3(VS_OUTPUT In) : COLOR
{   
    float4 Color;
	
	float2 t0 = float2( 0.5/MAP_WIDTH, 0.0/MAP_HEIGHT);// E
	float2 t1 = float2(-0.5/MAP_WIDTH, 0.0/MAP_HEIGHT);// 
	float2 t2 = float2( 0.0/MAP_WIDTH, 0.5/MAP_HEIGHT);// 
	float2 t3 = float2( 0.0/MAP_WIDTH,-0.5/MAP_HEIGHT);// 
	
	// 傫ڂ摜Əڂ摜̍
	Color  = tex2D( SrcSamp, In.Tex0    ) - tex2D( SrcSamp2, In.Tex1    );
	Color += tex2D( SrcSamp, In.Tex0+t0 ) - tex2D( SrcSamp2, In.Tex1+t0 );
	Color += tex2D( SrcSamp, In.Tex0+t1 ) - tex2D( SrcSamp2, In.Tex1+t1 );
	Color += tex2D( SrcSamp, In.Tex0+t2 ) - tex2D( SrcSamp2, In.Tex1+t2 );
	Color += tex2D( SrcSamp, In.Tex0+t3 ) - tex2D( SrcSamp2, In.Tex1+t3 );
	
	return 10.0f*Color;
}
// -------------------------------------------------------------
// eNjbN
// -------------------------------------------------------------
technique TShader
{
    pass P0
    {
        // V[̕`
        VertexShader = compile vs_1_1 VS();
        PixelShader  = compile ps_2_0 PS();
    }
    pass P1
    {
        // kobt@֖邢`
        PixelShader  = compile ps_2_0 PS_Reduction();
    }
    pass P2
    {
        // ɐL΂
        VertexShader = compile vs_1_1 VS_pass1();
        PixelShader  = compile ps_2_0 PS_pass1();
    }
    pass P3
    {
        // ɐL΂
        VertexShader = compile vs_1_1 VS_pass2();
        PixelShader  = compile ps_2_0 PS_pass2();
    }
    pass P4
    {
        // ŏIIɍ
        PixelShader  = compile ps_2_0 PS_pass3();
    }
}
